/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using Battlehub.RTCommon;using MeshVR;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using System;using UnityEngine.EventSystems;using UnityEngine.UI;namespace PluginIdea.ContexMenuSystem{    public class ContexMenuSystem : MVRScript, IGL    {        public const string CoreModule = "CoreModule";        public const string SettingModule = "SettingModule";        public const string VisualizeModule = "VisualizeModule";        public const string InputModule = "InputModule";        public JSONStorableAction.ActionCallback systemMenuAction;        public JSONStorableAction.ActionCallback sceneCommonMenuAction;        public JSONStorableAction.ActionCallback scenePersonMenuAction;        private CameraHook cameraHook;        private Request request;        private bool isResourcesLoaded;        private Dictionary<string, CMModuleBase> uid2Modules = new Dictionary<string, CMModuleBase>();        private Dictionary<string, Shader> dic_name2Shader = new Dictionary<string, Shader>();        private List<RaycastResult> castList = new List<RaycastResult>();        private RaycastHit raycastHit;        private RaycastHit[] tmpRaycastHits = new RaycastHit[5];        private TimerManager timerManager;        public static Atom containerAtom;        public TimerManager TimerManager        {            get { return timerManager; }        }        public RaycastHit RaycastHit        {            get { return raycastHit; }        }        public List<RaycastResult> CastList        {            get { return castList; }        }        public bool IsHitSomthing        {            get { return isUICast || isHitObject; }        }        public Dictionary<string, Shader> Dic_name2Shader        {            get { return dic_name2Shader; }        }        private GameObject contextMenuObject;        public GameObject ContexMenuUIObject        {            get {                return contextMenuObject;            }        }        private GameObject subMenuObject;        public GameObject SubMenuObject        {            get            {                return subMenuObject;            }        }        public bool IsResourceLoaded        {            get { return this.isResourcesLoaded; }        }        public Transform CenterCameraTrans        {            get            {                if (Utils.IsInVR())                {                    if (SuperController.singleton.isOpenVR)                    {                        return SuperController.singleton.ViveCenterCamera.transform;                    }                    return SuperController.singleton.OVRCenterCamera.transform;                }                else                {                    return SuperController.singleton.MonitorCenterCamera.transform;                }            }        }        public override void Init()        {            base.Init();            DataInit();            UIInit();            EventInit();        }        private void Start()        {            if (Utils.IsInVR())            {                cameraHook = Utils.GetSafeComponent<CameraHook>(CenterCameraTrans.gameObject);                cameraHook.onPostRenderCallback += OnPostRender;            }            else            {                if (GLRenderer.Instance == null)                {                    new GameObject                    {                        name = "GLRenderer"                    }.AddComponent<GLRenderer>();                }                GLRenderer.Instance.Add(this);            }        }                private void DataInit()        {            containerAtom = containingAtom;            timerManager = new TimerManager();            string assetsBundlePath = Utils.GetPluginPath(this) + "/resources/contexmenu.assetbundle";            request = new Request { path = assetsBundlePath, callback = OnAssetBundleLoaded };            AssetLoader.QueueLoadAssetBundleFromFile(request);        }        private void OnAssetBundleLoaded(Request abffr)        {            var subMenuAs = abffr.assetBundle.LoadAsset<GameObject>("Menu Item");            subMenuObject = Instantiate<GameObject>(subMenuAs);            var subMenuMono = Utils.GetSafeComponent< ContextMenuItem>(subMenuObject);            subMenuMono.textLabel = subMenuObject.transform.Find("Text").GetComponent<Text>();            subMenuMono.subMenuArrow = subMenuObject.transform.Find("Sub Menu Arrow").GetComponent<Text>();            Button.ButtonClickedEvent onClick = subMenuMono.GetComponent<Button>().onClick;            onClick.RemoveAllListeners();            onClick.AddListener(subMenuMono.OnClick);            var contexMenuAs = abffr.assetBundle.LoadAsset<GameObject>("Context Menu");            contextMenuObject = Instantiate<GameObject>(contexMenuAs);            var contexMenuMono = Utils.GetSafeComponent<ContextMenu>(contextMenuObject);            contexMenuMono.selector = contextMenuObject.transform.Find("Selector").gameObject;            contexMenuMono.menuLayout = contexMenuMono.transform.Find("Menu").GetComponent<VerticalLayoutGroup>();            contexMenuMono.menuItemPrefab = subMenuObject.GetComponent<ContextMenuItem>();            var shaders = abffr.assetBundle.LoadAllAssets<Shader>();            if (shaders.Length > 0)            {                for (int i = 0; i < shaders.Length; i++)                {                    if (!dic_name2Shader.ContainsKey(shaders[i].name)) dic_name2Shader.Add(shaders[i].name, shaders[i]);                }            }            isResourcesLoaded = true;            ReApplyUIParameter();        }        private void UIInit()        {            Utils.OnInitUI(CreateUIElement);        }        bool isUICast;        bool isHitObject;        private void Update()        {                        timerManager.Update();            foreach (var module in uid2Modules.Values.ToList())            {                module.OnUpdate();            }        }        private void LateUpdate()        {            foreach (var module in uid2Modules.Values.ToList())            {                module.OnLateUpdate();            }        }        private void EventInit()        {            RegisterModule(CoreModule, new CoreModule(this));            RegisterModule(SettingModule, new SettingModule(this));            RegisterModule(VisualizeModule, new VisualizeModule(this));            RegisterModule(InputModule, new InputModule(this));            SuperController.singleton.BroadcastMessage("OnActionsProviderAvailable", this, SendMessageOptions.DontRequireReceiver);        }                private void RegisterModule(string key, CMModuleBase module)        {            if (!uid2Modules.ContainsKey(key))            {                uid2Modules.Add(key, module);                module.Init();            }        }        private void UnRegisterModule(string key)        {            if (uid2Modules.ContainsKey(key))            {                uid2Modules[key].UnInit();                uid2Modules.Remove(key);            }        }        private void ReApplyUIParameter()        {            if (uid2Modules.Count > 0)            {                foreach (var module in uid2Modules.Values.ToList())                {                    module.OnReApplyUIParameter();                }            }        }        public void OnBindingsListRequested(List<object> bindings)        {            bindings.Add(new JSONStorableAction("SystemMenu", systemMenuAction));            bindings.Add(new JSONStorableAction("SceneMenu", sceneCommonMenuAction));            bindings.Add(new JSONStorableAction("PersonMenu", scenePersonMenuAction));        }        private void OnDestroy()        {            if (uid2Modules.Count > 0)            {                foreach (var key in uid2Modules.Keys.ToList())                {                    UnRegisterModule(key);                }                uid2Modules.Clear();            }            if (Utils.IsInVR())            {                Destroy(cameraHook);            }            else            {                GLRenderer.Instance.Remove(this);            }            Utils.OnDestroyUI();            SuperController.singleton.BroadcastMessage("OnActionsProviderDestroyed", this, SendMessageOptions.DontRequireReceiver);            Destroy(subMenuObject);            Destroy(contextMenuObject);        }                public GraphicRaycaster RaycastInCanvas;        public bool GetUIRaycastList()        {                        if (!EventSystem.current.IsPointerOverGameObject()) return false;            var selectedAtom = SuperController.singleton.GetSelectedAtom();            if (selectedAtom != null)            {                RaycastInCanvas = selectedAtom.GetComponentInChildren<GraphicRaycaster>();                if (RaycastInCanvas != null)                {                    castList.Clear();                    CheckGuiRaycastObjects(castList);                    if (castList.Count > 0) return true;                }            }            else            {                var cur = EventSystem.current.currentSelectedGameObject;                if (cur != null)                {                    RaycastInCanvas = cur.GetComponentInParent<GraphicRaycaster>();                    if (RaycastInCanvas != null)                    {                        castList.Clear();                        CheckGuiRaycastObjects(castList);                        if (castList.Count > 0) return true;                    }                }            }                       return false;        }        private void CheckGuiRaycastObjects(List<RaycastResult> list)        {            PointerEventData eventData = new PointerEventData(EventSystem.current);            eventData.pressPosition = Input.mousePosition;            eventData.position = Input.mousePosition;            RaycastInCanvas.Raycast(eventData, list);        }        public bool IsCastObject()        {            Ray ray = SuperController.singleton.MonitorCenterCamera.ScreenPointToRay(Input.mousePosition);            return Physics.Raycast(ray, out raycastHit, Mathf.Infinity);        }        public bool GetRaycastObject()        {            Ray ray = SuperController.singleton.MonitorCenterCamera.ScreenPointToRay(Input.mousePosition);            tmpRaycastHits = new RaycastHit[5];            int hitCount = Physics.RaycastNonAlloc(ray, tmpRaycastHits, Mathf.Infinity);            if (hitCount > 0)            {                for (int i = 0; i < tmpRaycastHits.Length; i++)                {                                        if (tmpRaycastHits[i].collider != null)                    {                        bool isController = tmpRaycastHits[i].collider.GetComponent<FreeControllerV3>() != null;                        if (isController)                        {                            raycastHit = tmpRaycastHits[i];                            return true;                        }                    }                }            }            return Physics.Raycast(ray, out raycastHit, Mathf.Infinity);        }                private void OnPostRender()        {            foreach (var module in uid2Modules.Values.ToList())            {                module.OnPostRender();            }        }        public void Draw(int cullingMask)        {            OnPostRender();        }    }}