/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using UnityEngine.UI;using System.Collections.Generic;using UnityEngine.EventSystems;namespace PluginIdea.ContexMenuSystem{    public class ContextMenu : MonoBehaviour, IPointerExitHandler    {        public static Vector3 startingClickPosition;        Canvas canvas;        public VerticalLayoutGroup menuLayout;        public GameObject selector;        public ContextMenuItem menuItemPrefab;        [HideInInspector]        public ContextMenu parentMenu;        [HideInInspector]        public List<ContextMenuItem> menuItems = new List<ContextMenuItem>();        public const float HoverTimer = 0f;        void Start()        {            Transform lastChecked = transform.parent;            while (canvas == null && lastChecked != null)            {                canvas = lastChecked.GetComponent<Canvas>();                lastChecked = lastChecked.parent;            }            gameObject.SetActive(false);        }        void Update()        {            if (Input.GetMouseButtonDown(0))                StartCoroutine(DelayHide());        }        private IEnumerator DelayHide()        {            yield return new WaitForSeconds(.2f);            Hide();        }        public static void HideAllMenus()        {            ContextMenu[] openMenus = FindObjectsOfType<ContextMenu>();            for (int i = 0; i < openMenus.Length; i++)                openMenus[i].Hide();        }        public void Show()        {            gameObject.SetActive(true);        }        public void ShowAtMousePosition()        {            gameObject.SetActive(true);            RectTransform transform = ((RectTransform)base.transform);            startingClickPosition = Input.mousePosition;            if (canvas.renderMode == RenderMode.ScreenSpaceOverlay)                transform.position = startingClickPosition;            else                transform.position = ConvertMouseToGUISpace(canvas);            if (startingClickPosition.y > Screen.height / 2)                transform.anchoredPosition -= new Vector2(0, transform.sizeDelta.y);            if (startingClickPosition.x > Screen.width / 2)                transform.anchoredPosition -= new Vector2(transform.sizeDelta.x, 0);        }        public void Hide()        {            gameObject.SetActive(false);            selector.SetActive(false);            for (int i = 0; i < menuItems.Count; i++)                if (menuItems[i].subMenu != null)                {                    menuItems[i].StopAllCoroutines();                    menuItems[i].keepMenuOpen = false;                    menuItems[i].subMenu.Hide();                }        }        public void AddMenuItem(string description, ContextMenuItem.StandardDelegate onClickMethod)        {            AddMenuItem(description, onClickMethod, null);        }        public void AddMenuItem(string description, ContextMenuItem.StandardDelegate onClickMethod, ContextMenu subMenu)        {            ContextMenuItem temp = Instantiate<GameObject>(menuItemPrefab.gameObject).GetComponent<ContextMenuItem>();            temp.transform.SetParent(menuLayout.transform);            temp.transform.localScale = Vector3.one;            temp.transform.localPosition = Vector3.zero;            temp.Initialise(this, description, onClickMethod, subMenu);            menuItems.Add(temp);        }        public void FinaliseMenu()        {            ((RectTransform)transform).sizeDelta = new Vector2(((RectTransform)transform).sizeDelta.x, menuItems.Count * ((RectTransform)selector.transform).sizeDelta.y + menuLayout.padding.top + menuLayout.padding.bottom);        }        public void SupressHiding()        {            for (int i = 0; i < menuItems.Count; i++)                menuItems[i].keepMenuOpen = true;            selector.SetActive(true);        }        public void OnPointerExit(PointerEventData eventData)        {            selector.SetActive(false);        }        public void CloseOtherSubMenus(ContextMenuItem caller)        {            for (int i = 0; i < menuItems.Count; i++)                if (menuItems[i].subMenu != null)                    if (!caller.Equals(menuItems[i]))                        menuItems[i].subMenu.Hide();        }        public static RectTransform GetHighestMenu(ContextMenu menu)        {            while (menu.parentMenu != null)                menu = menu.parentMenu;            return menu.transform as RectTransform;        }        static Vector3 ConvertMouseToGUISpace(Canvas canvas)        {            Vector2 position;            RectTransformUtility.ScreenPointToLocalPointInRectangle(canvas.transform as RectTransform, Input.mousePosition, canvas.worldCamera, out position);            return canvas.transform.TransformPoint(position);        }    }}