/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

​using System;using System.Collections;using System.Collections.Generic;using UnityEngine;namespace PluginIdea.ContexMenuSystem{    public class PathHelper    {                public static void GetWayPoints(Vector3[] points, int amountRadio, ref List<Vector3> wayPoints)        {            if (points == null || points.Length <= 1) { Debug.Log("points is empty!"); return; }            wayPoints.Clear();            Vector3[] vector3s = PathControlPointGenerator(points);            Vector3 prevPt = Interp(vector3s, 0);            int SmoothAmount = (points.Length - 1) * amountRadio;            for (int i = 1; i <= SmoothAmount; i++)            {                float pm = (float)i / SmoothAmount;                Vector3 currPt = Interp(vector3s, pm);                wayPoints.Add(currPt);                prevPt = currPt;            }        }                public static void DrawPathHelper(Vector3[] path, Color color, int SmoothRadio = 20, Transform trans = null)        {            Vector3[] vector3s = PathControlPointGenerator(path);            Vector3 prevPt = Interp(vector3s, 0);            int SmoothAmount = path.Length * SmoothRadio;            for (int i = 1; i <= SmoothAmount; i++)            {                float pm = (float)i / SmoothAmount;                Vector3 currPt = Interp(vector3s, pm);                GLDrawHelper.DrawLine3D(new List<GLLine3D> { new GLLine3D() { from = currPt, to = prevPt, color = color } }, trans);                prevPt = currPt;            }        }                public static float PathLength(Vector3[] path)        {            float pathLength = 0;            Vector3[] vector3s = PathControlPointGenerator(path);            Vector3 prevPt = Interp(vector3s, 0);            int SmoothAmount = path.Length * 20;            for (int i = 1; i <= SmoothAmount; i++)            {                float pm = (float)i / SmoothAmount;                Vector3 currPt = Interp(vector3s, pm);                pathLength += Vector3.Distance(prevPt, currPt);                prevPt = currPt;            }            return pathLength;        }                private static Vector3[] PathControlPointGenerator(Vector3[] path)        {            Vector3[] suppliedPath;            Vector3[] vector3s;            suppliedPath = path;            int offset = 2;            vector3s = new Vector3[suppliedPath.Length + offset];            Array.Copy(suppliedPath, 0, vector3s, 1, suppliedPath.Length);                        vector3s[0] = vector3s[1] + (vector3s[1] - vector3s[2]);            vector3s[vector3s.Length - 1] = vector3s[vector3s.Length - 2] + (vector3s[vector3s.Length - 2] - vector3s[vector3s.Length - 3]);                        if (vector3s[1] == vector3s[vector3s.Length - 2])            {                Vector3[] tmpLoopSpline = new Vector3[vector3s.Length];                Array.Copy(vector3s, tmpLoopSpline, vector3s.Length);                tmpLoopSpline[0] = tmpLoopSpline[tmpLoopSpline.Length - 3];                tmpLoopSpline[tmpLoopSpline.Length - 1] = tmpLoopSpline[2];                vector3s = new Vector3[tmpLoopSpline.Length];                Array.Copy(tmpLoopSpline, vector3s, tmpLoopSpline.Length);            }            return (vector3s);        }                private static Vector3 Interp(Vector3[] pts, float t)        {            int numSections = pts.Length - 3;            int currPt = Mathf.Min(Mathf.FloorToInt(t * (float)numSections), numSections - 1);            float u = t * (float)numSections - (float)currPt;            Vector3 a = pts[currPt];            Vector3 b = pts[currPt + 1];            Vector3 c = pts[currPt + 2];            Vector3 d = pts[currPt + 3];            return .5f * (                (-a + 3f * b - 3f * c + d) * (u * u * u) +                (2f * a - 5f * b + 4f * c - d) * (u * u) +                (-a + c) * u +                2f * b            );        }    }}​