/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using System;using UnityEngine.EventSystems;using UnityEngine.UI;using UnityEngine.Events;namespace PluginIdea.ContexMenuSystem{    public class CallbackData    {        public string text;        public OptBase opt;        public ContextMenu subContex;        public GameObject buttonObject;    }    public class CoreModule : CMModuleBase    {        private Canvas popupCanvas;        private CommandClass commandClass;        private Dictionary<string, CallbackData> dic_callbacks = new Dictionary<string, CallbackData>();        private GameObject buttonTemplate;        private float rbmHoldTime;        public CoreModule(ContexMenuSystem ower)        {            this.ower = ower;        }        public override void Init()        {            Utils.SetupInfoText(ower, "<size=35><b>Contex Menu System Beta </b></size>\n\n" +                "Left Alt + Mouse Right : Open System Menu\n" +                "Mouse Right : Open Common Menu", 500, true);            popupCanvas = Utils.AppendCanvasObjectUnderHeadCenter("ContexViewSpaceCanvas", true);            var canvasObj = popupCanvas.gameObject;            ower.systemMenuAction += CreateSystemMenu;            ower.sceneCommonMenuAction += CreateSceneCommonMenu;            ower.scenePersonMenuAction += CreatePersonMenu;        }        public override void OnReApplyUIParameter()        {            commandClass = new CommandClass(ower.ContexMenuUIObject, popupCanvas.transform);                                }        public override void OnUpdate()        {            if (Input.GetMouseButtonDown(1))            {                rbmHoldTime = 0;            }            rbmHoldTime += Time.deltaTime;            if (Input.GetMouseButtonUp(1) && rbmHoldTime < 0.2f)            {                                if (Input.GetKey(KeyCode.LeftAlt))                {                    CreateSystemMenu();                }                                else                {                    CreateSceneCommonMenu();                }            }        }        private void CreateSystemMenu()        {            commandClass.CreateMenuTree(new CheckInfo() { type = CommandType.CommonMenu, hit = ower.RaycastHit });            ower.TimerManager.AddTimer(.1f, () => {                commandClass.ShowAtMousePosition(MenuType.SystemMenu);            });        }        private void CreatePersonMenu()        {            bool isHitObject = ower.GetRaycastObject();            if (!isHitObject && EventSystem.current.IsPointerOverGameObject()) return;            var atom = ower.RaycastHit.collider?.GetComponentInParent<Atom>();            if (atom != null && atom.type == "Person")            {                commandClass.CreateMenuTree(new CheckInfo() { type = CommandType.PersonMenu, hit = ower.RaycastHit, target = atom });                ower.TimerManager.AddTimer(.1f, () => {                    commandClass.ShowAtMousePosition(MenuType.PersonMenu);                });            }        }        private void CreateSceneCommonMenu()        {            bool isHitObject = ower.GetRaycastObject();            bool isUICast = ower.GetUIRaycastList();            if (!isUICast && !isHitObject) return;            CheckInfo checkInfo;            if (CommandCheck.CheckRightClick(ower.RaycastHit, ower.CastList, out checkInfo))            {                Debug.Log(checkInfo.target.name);                commandClass.CreateMenuTree(checkInfo);                                ower.TimerManager.AddTimer(.1f, () => {                    commandClass.ShowAtMousePosition(MenuType.SceneCommonMenu);                });            }        }        public override void UnInit()        {            if (popupCanvas != null)            {                dic_callbacks.Clear();                GameObject.Destroy(popupCanvas.gameObject);                commandClass.UnInit();            }            ower.systemMenuAction -= CreateSystemMenu;            ower.sceneCommonMenuAction -= CreateSceneCommonMenu;            ower.scenePersonMenuAction -= CreatePersonMenu;        }    }}