/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using System;using UnityEngine.EventSystems;using UnityEngine.UI;using UnityEngine.Events;namespace PluginIdea.ContexMenuSystem{    public class VisualizeModule : CMModuleBase    {        private List<Renderer> effectiveMrs = new List<Renderer>();        private Atom lastSelectedAtom;        private bool isOnDraw;        private JSONStorableColor wireColor;        private JSONStorableFloat outlineWidth;        private float OutlineWidth        {            set            {                if (isOnDraw && effectiveMrs.Count > 0)                {                    effectiveMrs.ForEach(mr => {                        Material tmpMat = mr.materials[mr.materials.Length - 1];                        tmpMat.SetFloat("_Width", value);                    });                }            }        }        private Color Color        {            set            {                if (isOnDraw && effectiveMrs.Count > 0)                {                    effectiveMrs.ForEach(mr => {                        Material tmpMat = mr.materials[mr.materials.Length - 1];                        tmpMat.SetColor("_OutlineColor", value);                    });                }            }        }        public VisualizeModule(ContexMenuSystem ower)        {            this.ower = ower;        }        public override void Init()        {            Utils.SetupInfoTextNoScroll(this.ower, "<size=30><b>OutLine</b></size>", 35, false);            wireColor = Utils.SetupColor(ower, "Outline Color", Color.green, false);            outlineWidth = Utils.SetupSliderFloat(ower, "Outline Width", 0.005f, 0f, 0.1f, false);            outlineWidth.setCallbackFunction = (val) => { OutlineWidth = val; };            wireColor.setCallbackFunction = (h, s, v) => { Color = Color.HSVToRGB(h, s, v); };        }        public override void OnReApplyUIParameter()        {            outlineWidth.setCallbackFunction(outlineWidth.val);            wireColor.setCallbackFunction(wireColor.val.S, wireColor.val.H, wireColor.val.V);        }        public override void OnUpdate()        {            if (GlobalSetting.showOutLine)            {                if (!EventSystem.current.IsPointerOverGameObject() && ower.IsCastObject())                {                    var hit = ower.RaycastHit;                    Atom atom = hit.collider.GetComponentInParent<Atom>();                    if (atom == null || atom.type == "Person") return;                    if (lastSelectedAtom != atom)                        DrawAtom(atom);                }            }        }        public void DrawAtom(Atom atom)        {                        if (isOnDraw) SetIsDraw(false);            atom.GetComponentsInChildren<Renderer>(effectiveMrs);                        SetIsDraw(true);        }        private void SetIsDraw(bool isDraw)        {            if (effectiveMrs.Count > 0)            {                isOnDraw = isDraw;                effectiveMrs.ForEach(r =>                {                    if (r != null && !string.IsNullOrEmpty(r.name) && r.name != "SphereRender")                    {                        if (isDraw)                        {                            List<Material> tmpMats = r.materials.ToList();                            Material tmpMat = new Material(ower.Dic_name2Shader["PluginIdea/SimpleOutline"]);                            tmpMat.SetColor("_OutlineColor", Color.HSVToRGB(wireColor.val.H, wireColor.val.S, wireColor.val.V));                            tmpMat.SetFloat("_Width", outlineWidth.val);                            tmpMats.Add(tmpMat);                            r.materials = tmpMats.ToArray();                        }                        else                        {                            List<Material> tmpMats = r.materials.ToList();                            tmpMats.RemoveAt(tmpMats.Count - 1);                            r.materials = tmpMats.ToArray();                        }                    }                });            }        }        public override void OnPostRender()        {            if (GlobalSetting.showHitNormal)            {                                                                                            }        }        public override void UnInit()        {            if (isOnDraw) SetIsDraw(false);        }    }}